
-- AUTOMAT : tlacitka START, STOP (posledni stisknute), vystup

package automat_package is
  type vst_abeceda is (START,STOP);
  type vyst_abeceda is (ZAPNUTO,VYPNUTO);
end automat_package;

use work.automat_package.all;
entity automat is
  port (
    signal vstup  : in vst_abeceda;
    signal vystup : out vyst_abeceda
  );
end automat;

architecture valeko of automat is

type stav_abeceda is (Q0,Q1);
signal stav : stav_abeceda;

function prechodova_funkce(stav: stav_abeceda; vstup: vst_abeceda) return stav_abeceda is
begin
 case vstup is
  when START => return Q0;
  when STOP  => return Q1;
 end case; 
end;

function vystupni_funkce(stav: stav_abeceda) return vyst_abeceda is
begin
 case stav is
  when Q0 => return ZAPNUTO;
  when Q1 => return VYPNUTO;
 end case; 
end;

begin

process (vstup'transaction)
begin
  stav <= prechodova_funkce(stav,vstup);
end process;

process (stav)
begin
  vystup <= vystupni_funkce(stav);
end process;

end valeko;

--------------------------------------

use work.automat_package.all;
entity empty is
end empty;

architecture testbench of empty is
  signal vstup : vst_abeceda;
  signal vystup: vyst_abeceda;
  component automat
  port (
    vstup : in  vst_abeceda;
    vystup: out vyst_abeceda
  );
  end component;
begin
  TEST: automat port map (vstup, vystup);
  process
  begin
    vstup <= START;
    wait for 50 ns;
    vstup <= STOP;
    wait for 50 ns;
    vstup <= START;
    wait;
  end process;
end testbench;
