library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity MH7472 is
port (
  J:  in  STD_LOGIC_VECTOR(0 to 2);
  K:  in  STD_LOGIC_VECTOR(0 to 2);
  R:  in  STD_LOGIC;
  S:  in  STD_LOGIC;
  CL: in  STD_LOGIC;
  Q:  out STD_LOGIC;
  Qn: out STD_LOGIC
);
end MH7472;

architecture VALEKO of MH7472 is
signal NAND1,NAND2,AND1,AND2,AND3,AND4,NOR1,NOR2,AND5,AND6 : STD_LOGIC;
signal INT1,INT2,INT3,INT4,INT5,INT6,INT7,INT8,INT9,INT0  : STD_LOGIC;
signal INTQ,INTQn : STD_LOGIC;
begin

NAND1 <= not(INT1 and INTQn and S);
INTQ <= 'X',NAND1 after 15 ns;
Q <= INTQ;

NAND2 <= not(INTQ and INT2 and R);
INTQn <= 'X',NAND2 after 15 ns;
Qn <= INTQn;

AND1 <= (INT2 and R and INT4);
INT3 <= 'X',AND1 after 10 ns;

AND2 <= (S and INT1 and INT6);
INT5 <= 'X',AND2 after 10 ns;

AND3 <= (INT4 and R);
INT7 <= 'X',AND3 after 10 ns;

AND4 <= (INT6 and S);
INT8 <= 'X',AND4 after 10 ns;

NOR1 <= (INT7 nor INT9);
INT6 <= 'X',NOR1 after 10 ns;

NOR2 <= (INT8 nor INT0);
INT4 <= 'X',NOR2 after 10 ns;

AND5 <= (R and INTQn and J(0) and J(1) and J(2) and CL);
INT9 <= 'X',AND5 after 10 ns;

AND6 <= (INTQ and S and CL and K(0) and K(1) and K(2));
INT0 <= 'X',AND6 after 10 ns;

INT1 <= (not INT3) or CL;
INT2 <= (not INT5) or CL;

end VALEKO;

---------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
entity TB_MH7472 is
end TB_MH7472;

architecture TB_CATALOG of TB_MH7472 is
  signal J: STD_LOGIC_VECTOR(0 to 2);
  signal K: STD_LOGIC_VECTOR(0 to 2);
  signal CL,R,S,Q,Qn : STD_LOGIC;

  component MH7472
  port (
    J:  in  STD_LOGIC_VECTOR(0 to 2);
    K:  in  STD_LOGIC_VECTOR(0 to 2);
    R:  in  STD_LOGIC;
    S:  in  STD_LOGIC;
    CL: in  STD_LOGIC;
    Q:  out STD_LOGIC;
    Qn: out STD_LOGIC
  );
  end component;

begin  

  TEST: MH7472 port map (J,K,R,S,CL,Q,Qn);

  process
  begin
    J<="011"; K<="111"; CL<='0'; R<='0'; S<='0'; -- 1
    wait for 50 ns;
    J<="011"; K<="111"; CL<='0'; R<='0'; S<='1'; -- 2
    wait for 50 ns;
    J<="011"; K<="111"; CL<='0'; R<='1'; S<='1'; -- 3
    wait for 50 ns;
    J<="011"; K<="111"; CL<='1'; R<='1'; S<='1'; -- 4
    wait for 50 ns;
    J<="011"; K<="111"; CL<='0'; R<='1'; S<='1'; -- 5
    wait for 50 ns;

    J<="101"; K<="111"; CL<='0'; R<='1'; S<='1'; -- 6
    wait for 50 ns;
    J<="101"; K<="111"; CL<='1'; R<='1'; S<='1'; -- 7
    wait for 50 ns;
    J<="101"; K<="111"; CL<='0'; R<='1'; S<='1'; -- 8
    wait for 50 ns;
    J<="110"; K<="111"; CL<='0'; R<='1'; S<='1'; -- 9
    wait for 50 ns;
    J<="110"; K<="111"; CL<='1'; R<='1'; S<='1'; --10
    wait for 50 ns;

    J<="110"; K<="111"; CL<='0'; R<='1'; S<='1'; --11
    wait for 50 ns;
    J<="111"; K<="111"; CL<='1'; R<='1'; S<='1'; --12
    wait for 50 ns;
    J<="000"; K<="111"; CL<='1'; R<='1'; S<='1'; --13
    wait for 50 ns;
    J<="000"; K<="111"; CL<='0'; R<='1'; S<='1'; --14
    wait for 50 ns;
    J<="000"; K<="111"; CL<='1'; R<='1'; S<='1'; --15
    wait for 50 ns;

    J<="000"; K<="111"; CL<='0'; R<='1'; S<='1'; --16
    wait for 50 ns;
    J<="111"; K<="011"; CL<='0'; R<='0'; S<='0'; --17
    wait for 50 ns;
    J<="111"; K<="011"; CL<='0'; R<='1'; S<='0'; --18
    wait for 50 ns;
    J<="111"; K<="011"; CL<='0'; R<='1'; S<='1'; --19
    wait for 50 ns;
    J<="111"; K<="011"; CL<='1'; R<='1'; S<='1'; --20
    wait for 50 ns;

    J<="111"; K<="011"; CL<='0'; R<='1'; S<='1'; --21
    wait for 50 ns;
    J<="111"; K<="101"; CL<='0'; R<='1'; S<='1'; --22
    wait for 50 ns;
    J<="111"; K<="101"; CL<='1'; R<='1'; S<='1'; --23
    wait for 50 ns;
    J<="111"; K<="101"; CL<='0'; R<='1'; S<='1'; --24
    wait for 50 ns;
    J<="111"; K<="110"; CL<='0'; R<='1'; S<='1'; --25
    wait for 50 ns;

    J<="111"; K<="110"; CL<='1'; R<='1'; S<='1'; --26
    wait for 50 ns;
    J<="111"; K<="110"; CL<='0'; R<='1'; S<='1'; --27
    wait for 50 ns;
    J<="111"; K<="111"; CL<='1'; R<='1'; S<='1'; --28
    wait for 50 ns;
    J<="111"; K<="000"; CL<='1'; R<='1'; S<='1'; --29
    wait for 50 ns;
    J<="111"; K<="000"; CL<='0'; R<='1'; S<='1'; --30
    wait for 50 ns;

    J<="111"; K<="000"; CL<='1'; R<='1'; S<='1'; --31
    wait for 50 ns;
    J<="111"; K<="000"; CL<='0'; R<='1'; S<='1'; --32
    wait for 50 ns;
  end process;

end TB_CATALOG;

architecture TB_MEASURE of TB_MH7472 is
  signal J: STD_LOGIC_VECTOR(0 to 2);
  signal K: STD_LOGIC_VECTOR(0 to 2);
  signal CL,R,S,Q,Qn : STD_LOGIC;

  component MH7472
  port (
    J:  in  STD_LOGIC_VECTOR(0 to 2);
    K:  in  STD_LOGIC_VECTOR(0 to 2);
    R:  in  STD_LOGIC;
    S:  in  STD_LOGIC;
    CL: in  STD_LOGIC;
    Q:  out STD_LOGIC;
    Qn: out STD_LOGIC
  );
  end component;

begin  

  TEST: MH7472 port map (J,K,R,S,CL,Q,Qn);

  process
  begin
    J<="000"; K<="111"; CL<='0'; R<='1'; S<='0';
    wait for 50 ns;
    J<="000"; K<="111"; CL<='0'; R<='1'; S<='1'; --2,3 : 30 ns, 15 ns
    wait for 50 ns;
    J<="000"; K<="111"; CL<='0'; R<='0'; S<='1'; --1,4 : 15 ns, 30 ns
    wait for 50 ns;

    J<="111"; K<="000"; CL<='1'; R<='1'; S<='1';
    wait for 50 ns;
    J<="111"; K<="000"; CL<='0'; R<='1'; S<='1'; --5,8 : 15 ns, 30 ns
    wait for 50 ns;
    J<="000"; K<="111"; CL<='1'; R<='1'; S<='1';
    wait for 50 ns;
    J<="000"; K<="111"; CL<='0'; R<='1'; S<='1'; --6,7 : 30 ns, 15 ns
    wait for 50 ns;

  end process;

end TB_MEASURE;
